## mlt 6.18.0

=== CMakeLists.txt ===
project(MLT)
set(MLT_VERSION 6.17.0)
cmake_minimum_required(VERSION 3.0)
find_package(PkgConfig REQUIRED)
include(GNUInstallDirs)
option(GPL "Enable GPLv2 modules" ON)
option(GPL3 "Enable GPLv3 modules" ON)
if(WIN32)
  option(NODEPLOY "Keep bin/ lib/ layout on Windows" ON)
endif()
if(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86_64)|(AMD64)")
    set(X86_64 ON)
    add_compile_definitions(USE_MMX USE_SSE USE_SSE2 ARCH_X86_64)
endif()
if(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang")
    add_compile_options(-ffast-math)
elseif(MSVC)
    add_compile_options(/fp:fast)
endif()
find_package(Threads REQUIRED)
add_subdirectory(src/framework)
add_subdirectory(src/melt)
add_subdirectory(src/mlt++)
#add_subdirectory(src/swig)
#file(GLOB modules src/modules/*/)
set(modules
    src/modules/avformat
    src/modules/core
    src/modules/decklink
    src/modules/frei0r
    src/modules/feeds
    src/modules/gtk2
    src/modules/kdenlive
    src/modules/motion_est
    src/modules/normalize
    src/modules/oldfilm
    src/modules/opencv
    src/modules/plus
    src/modules/plusgpl
    src/modules/qt
    src/modules/rtaudio
    src/modules/sdl2
    src/modules/vid.stab
    src/modules/vmfx
    src/modules/xine
    src/modules/xml
)
foreach(module ${modules})
    add_subdirectory(${module})
endforeach()

=== src/framework/CMakeLists.txt ===
file(GLOB mlt_src *.c)
if(WIN32)
    list(APPEND mlt_src ../win32/win32.c ../win32/strptime.c)
endif()
add_library(mlt SHARED ${mlt_src})
set_target_properties (mlt PROPERTIES SOVERSION ${MLT_VERSION} VERSION 6)
if(WIN32)
    find_package(dlfcn-win32 REQUIRED)
    find_package(iconv REQUIRED)
    target_link_libraries(mlt dlfcn-win32::dl Iconv::Iconv)
    if(NODEPLOY)
        target_compile_definitions(mlt PRIVATE NODEPLOY)
    endif()
else()
    target_link_libraries(mlt dl)
endif()
if(NOT (WIN32 OR APPLE))
    target_compile_definitions(mlt PRIVATE
        PREFIX_DATA="${CMAKE_INSTALL_DATADIR}/mlt"
        PREFIX_LIB="${CMAKE_INSTALL_LIBDIR}/mlt")
endif()

target_link_libraries(mlt m Threads::Threads)
target_include_directories(mlt PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_include_directories(mlt PUBLIC  ${CMAKE_SOURCE_DIR}/src)

if(WIN32)
    install(TARGETS mlt DESTINATION ${CMAKE_INSTALL_BINDIR})
else()
    install(TARGETS mlt DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

file(GLOB mlt_head *.h)
install(FILES ${mlt_head} DESTINATION include/mlt)

configure_file(mlt-framework.pc.in mlt-framework.pc @ONLY)
install (FILES
    ${CMAKE_CURRENT_BINARY_DIR}/mlt-framework.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
    COMPONENT Development)
#configure_file(MLTConfig.cmake.in MLTConfig.cmake @ONLY)
#configure_file(MLTConfigVersion.cmake.in MLTConfigVersion.cmake @ONLY)
#install (FILES
#    ${CMAKE_CURRENT_BINARY_DIR}/MLTConfig.cmake
#    ${CMAKE_CURRENT_BINARY_DIR}/MLTConfigVersion.cmake
#    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/mlt
#    COMPONENT Development)

=== src/melt/CMakeLists.txt ===
set(melt_lib mlt Threads::Threads)
find_package(SDL2 QUIET)
if(TARGET SDL2::SDL2)
    add_library(sdl2 ALIAS SDL2::SDL2)
else()
    pkg_check_modules(sdl2 IMPORTED_TARGET GLOBAL sdl2)
    if(TARGET PkgConfig::sdl2)
        add_library(sdl2 ALIAS PkgConfig::sdl2)
    endif()
endif()
if(TARGET sdl2)
    if(MINGW)
        list(APPEND melt_lib mingw32)
    endif()
    list(APPEND melt_lib sdl2)
endif()
add_executable(melt melt.c io.c)
target_compile_definitions(melt PRIVATE VERSION="${MLT_VERSION}")
target_link_libraries(melt ${melt_lib})
install(TARGETS melt RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== src/modules/sdl2/CMakeLists.txt ===
find_package(SDL2 QUIET)
if(TARGET SDL2::SDL2)
    add_library(sdl2 ALIAS SDL2::SDL2)
else()
    pkg_check_modules(sdl2 IMPORTED_TARGET GLOBAL sdl2)
    if(TARGET PkgConfig::sdl2)
        add_library(sdl2 ALIAS PkgConfig::sdl2)
    endif()
endif()
if(TARGET sdl2)
    file(GLOB mltsdl2_src *.c)
    add_library(mltsdl2 MODULE ${mltsdl2_src})
    target_link_libraries(mltsdl2 mlt m Threads::Threads sdl2)
    install(TARGETS mltsdl2 LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/mlt)
    file(GLOB yml *.yml)
    install(FILES ${yml} DESTINATION ${CMAKE_INSTALL_DATADIR}/mlt/sdl2)
endif()

=== debian/changelog ===
mlt (6.18.0-4~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 04 Feb 2020 11:28:52 -0800

mlt (6.18.0-4) unstable; urgency=medium

  * Bump Standards-Version to 4.5.0.
  * Adjust source lintian-overrides.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 23 Jan 2020 16:33:03 +0100

mlt (6.18.0-3) unstable; urgency=medium

  * Add -latomic to LDFLAGS.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 19 Dec 2019 09:52:22 +0100

mlt (6.18.0-2) unstable; urgency=medium

  * Add patch 01-fix-link-atomic64 to fix a FTBFS.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 17 Dec 2019 10:18:04 +0100

mlt (6.18.0-1) unstable; urgency=medium

  * New upstream release.
    - Drop merged patch 01-python3.
  * Remove luma configure options again.
  * Use the new debhelper-compat notation, and drop the d/compat file.

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 20 Nov 2019 13:26:15 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Enable MMX and SSE on amd64 architecture
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), "amd64"))
	EXTRA_CONFIGURE_OPTS += --enable-mmx --enable-sse
else
	EXTRA_CONFIGURE_OPTS += --disable-mmx --disable-sse --disable-sse2
endif

DEB_CONFIGURE_EXTRA_FLAGS := \
	--enable-gpl \
	--enable-gpl3 \
	--enable-motion_est \
	$(EXTRA_CONFIGURE_OPTS) \
	--avformat-shared=/usr \
	--swig-languages=python \
	--qimage-libdir=/usr/lib \
	--disable-swfdec

PYTHON_DIR := usr/lib/python3/dist-packages

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CONFIGURE_EXTRA_FLAGS)

override_dh_auto_clean:
	[ ! -f config.mak ] || $(MAKE) distclean

override_dh_install:
	mkdir -p debian/python3-mlt/$(PYTHON_DIR)
	install -m 644 src/swig/python/mlt.py debian/python3-mlt/$(PYTHON_DIR)/mlt.py
	install -m 644 src/swig/python/_mlt.so debian/python3-mlt/$(PYTHON_DIR)/_mlt.so
	dh_install

override_dh_makeshlibs:
	dh_makeshlibs -V

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## mlt 6.20.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 project(MLT)
-set(MLT_VERSION 6.17.0)
+set(MLT_VERSION 6.19.0)
 cmake_minimum_required(VERSION 3.0)
 find_package(PkgConfig REQUIRED)
 include(GNUInstallDirs)
@@ -38,6 +38,7 @@
     src/modules/plus
     src/modules/plusgpl
     src/modules/qt
+    src/modules/rubberband
     src/modules/rtaudio
     src/modules/sdl2
     src/modules/vid.stab

=== Makefile ===
SUBDIRS = src/framework \
		  src/mlt++ \
		  src/melt \
		  src/modules \
		  src/swig \
		  profiles

all clean:
	list='$(SUBDIRS)'; \
	for subdir in $$list; do \
		$(MAKE) -s -C $$subdir depend || exit 1; \
		$(MAKE) -C $$subdir $@ || exit 1; \
	done

distclean:
	rm -f mlt-config packages.dat
	list='$(SUBDIRS)'; \
	for subdir in $$list; do \
		$(MAKE) -C $$subdir $@ || exit 1; \
	done
	echo > config.mak

dist-clean: distclean

include config.mak

install:
	install -d "$(DESTDIR)$(prefix)/bin"
	install -d "$(DESTDIR)$(prefix)/include"
	install -d "$(DESTDIR)$(libdir)"
	install -d "$(DESTDIR)$(moduledir)"
ifeq ($(extra_versioning), true)
	ln -s "$(moduledir)" "$(DESTDIR)$(unversionedmoduledir)"
endif
	install -d "$(DESTDIR)$(libdir)/pkgconfig"
	install -d "$(DESTDIR)$(mltdatadir)"
ifeq ($(extra_versioning), true)
	ln -s "$(mltdatadir)" "$(DESTDIR)$(unversionedmltdatadir)"
endif
	install -c -m 644 *.pc "$(DESTDIR)$(libdir)/pkgconfig"
	list='$(SUBDIRS)'; \
	for subdir in $$list; do \
		$(MAKE) DESTDIR=$(DESTDIR) -C $$subdir $@ || exit 1; \
	done
	cp -R presets "$(DESTDIR)$(mltdatadir)"

uninstall:
	rm -f "$(DESTDIR)$(bindir)"/mlt-config
	rm -f "$(DESTDIR)$(libdir)"/pkgconfig/mlt-framework.pc
	rm -f "$(DESTDIR)$(libdir)"/pkgconfig/mlt++.pc
	list='$(SUBDIRS)'; \
	for subdir in $$list; do \
		$(MAKE) DESTDIR=$(DESTDIR) -C $$subdir $@ || exit 1; \
	done
	rm -rf "$(DESTDIR)$(prefix)/include/mlt"
	rm -rf "$(DESTDIR)$(mltdatadir)"
ifeq ($(compat_dirs), true)
	rm -rf "$(DESTDIR)$(prefix)/share/mlt"
endif

dist:
	git archive --format=tar --prefix=mlt-$(version)/ v$(version) | gzip >mlt-$(version).tar.gz

validate-yml:
	for file in $$(find src/modules -type f -name \*.yml); do \
		echo "validate: $$file"; \
		kwalify -f src/framework/metaschema.yaml $$file || exit 1; \
	done

codespell:
	codespell -w -q 3 \
    -L shotcut,sav,boundry,percentil,readded,uint,ith,sinc,amin,childs,seeked,writen \
    -S ChangeLog,cJSON.c,cJSON.h,RtAudio.cpp,RtAudio.h,*.rej,mlt_wrap.*

=== src/framework/CMakeLists.txt ===
--- 
+++ 
@@ -16,8 +16,8 @@
 endif()
 if(NOT (WIN32 OR APPLE))
     target_compile_definitions(mlt PRIVATE
-        PREFIX_DATA="${CMAKE_INSTALL_DATADIR}/mlt"
-        PREFIX_LIB="${CMAKE_INSTALL_LIBDIR}/mlt")
+        PREFIX_DATA="${CMAKE_INSTALL_FULL_DATADIR}/mlt"
+        PREFIX_LIB="${CMAKE_INSTALL_FULL_LIBDIR}/mlt")
 endif()
 
 target_link_libraries(mlt m Threads::Threads)

=== src/framework/Makefile ===
include ../../config.mak
include config.mak

NAME = libmlt$(LIBSUF)
TARGET = $(NAME).$(version)

ifeq ($(targetos), Darwin)
NAME = libmlt$(LIBSUF)
TARGET = libmlt.$(version)$(LIBSUF)
SONAME = libmlt.$(soversion)$(LIBSUF)
SHFLAGS += -install_name $(libdir)/$(SONAME) -current_version $(version) -compatibility_version $(soversion)
else ifeq ($(targetos), MinGW)
NAME = libmlt$(LIBSUF)
TARGET = libmlt-$(soversion)$(LIBSUF)
SHFLAGS += -Wl,--output-def,libmlt.def
else
NAME = libmlt$(LIBSUF)
TARGET = $(NAME).$(version)
SONAME = $(NAME).$(soversion)
SHFLAGS += -Wl,-soname,$(SONAME)
endif

ifeq ($(targetos), Linux)
SHFLAGS += -Wl,--version-script=mlt.vers
endif

OBJS = mlt_frame.o \
	   mlt_version.o \
	   mlt_geometry.o \
	   mlt_deque.o \
	   mlt_property.o \
	   mlt_properties.o \
	   mlt_events.o \
	   mlt_parser.o \
	   mlt_service.o \
	   mlt_producer.o \
	   mlt_multitrack.o \
	   mlt_playlist.o \
	   mlt_consumer.o \
	   mlt_filter.o \
	   mlt_transition.o \
	   mlt_field.o \
	   mlt_tractor.o \
	   mlt_factory.o \
	   mlt_repository.o \
	   mlt_pool.o \
	   mlt_tokeniser.o \
	   mlt_profile.o \
	   mlt_log.o \
	   mlt_cache.o \
	   mlt_animation.o \
	   mlt_slices.o \
	   mlt_luma_map.o

INCS = mlt_consumer.h \
	   mlt_version.h \
	   mlt_factory.h \
	   mlt_filter.h \
	   mlt.h \
	   mlt_multitrack.h \
	   mlt_pool.h \
	   mlt_properties.h \
	   mlt_events.h \
	   mlt_parser.h \
	   mlt_repository.h \
	   mlt_tractor.h \
	   mlt_types.h \
	   mlt_deque.h \
	   mlt_field.h \
	   mlt_frame.h \
	   mlt_geometry.h \
	   mlt_playlist.h \
	   mlt_producer.h \
	   mlt_property.h \
	   mlt_service.h  \
	   mlt_transition.h \
	   mlt_tokeniser.h \
	   mlt_profile.h \
	   mlt_log.h \
	   mlt_cache.h \
	   mlt_animation.h \
	   mlt_slices.h \
	   mlt_luma_map.h

SRCS := $(OBJS:.o=.c)

ifeq ($(targetos), MinGW)
LDFLAGS += -liconv
OBJS += ../win32/win32.o ../win32/strptime.o
SRCS += ../win32/win32.c ../win32/strptime.c
endif

CFLAGS += $(RDYNAMIC) -DPREFIX_DATA="\"$(mltdatadir)\"" -DPREFIX_LIB="\"$(moduledir)\""

LDFLAGS += $(LIBDL) -lpthread -lm

all:	$(TARGET)

$(TARGET): $(OBJS)
		$(CC) $(SHFLAGS) -o $@ $(OBJS) $(LDFLAGS)
		ln -sf $(TARGET) $(NAME)
		if [ "$(targetos)" != "MinGW" ]; then \
			ln -sf $(TARGET) $(SONAME) ; \
		fi

depend:	$(SRCS)
	$(CC) -MM $(CFLAGS) $^ 1>.depend

distclean:	clean
		rm -f .depend

clean:	
		rm -f $(OBJS) $(TARGET) $(NAME) $(SONAME) libmlt.def

install:
	install -d $(DESTDIR)$(libdir)
	if [ "$(targetos)" = "MinGW" ]; then \
		if [ "$(windeploy)" = true ]; then \
			install -m 755 $(TARGET) "$(DESTDIR)$(prefix)" ; \
			install -m 755 $(TARGET) "$(DESTDIR)$(libdir)/libmlt.dll" ; \
		else \
			install -m 755 $(TARGET) "$(DESTDIR)$(bindir)" ; \
			install -m 755 $(TARGET) "$(DESTDIR)$(bindir)/libmlt.dll" ; \
		fi; \
		install -m 644 libmlt.def "$(DESTDIR)$(libdir)" ; \
	else \
		install -m 755 $(TARGET) $(DESTDIR)$(libdir) ; \
		ln -sf $(TARGET) $(DESTDIR)$(libdir)/$(SONAME) ; \
		ln -sf $(TARGET) $(DESTDIR)$(libdir)/$(NAME) ; \
	fi
	install -d "$(DESTDIR)$(prefix)/include/mlt/framework"
	install -m 644 $(INCS) "$(DESTDIR)$(prefix)/include/mlt/framework"
	install -d "$(DESTDIR)$(mltdatadir)"
	install -m 644 metaschema.yaml "$(DESTDIR)$(mltdatadir)"

uninstall:
	rm -f "$(DESTDIR)$(libdir)/$(TARGET)"
	if [ "$(targetos)" != "MinGW" ]; then \
		rm -f "$(DESTDIR)$(libdir)/$(SONAME)" ; \
		rm -f "$(DESTDIR)$(libdir)/$(NAME)" ; \
	else \
		if [ "$(windeploy)" = true ]; then \
			rm -f "$(DESTDIR)$(prefix)/$(TARGET)" ; \
			rm -f "$(DESTDIR)$(libdir)/libmlt.dll" ; \
		else \
			rm -f "$(DESTDIR)$(bindir)/$(TARGET)" ; \
			rm -f "$(DESTDIR)$(bindir)/libmlt.dll" ; \
		fi ; \
		rm -f "$(DESTDIR)$(libdir)/libmlt.def" ; \
	fi
	rm -rf "$(DESTDIR)$(prefix)/include/mlt/framework"
	rm -f "$(DESTDIR)$(mltdatadir)/metaschema.yaml"

ifneq ($(wildcard .depend),)
include .depend
endif

=== src/melt/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,11 @@
 set(melt_lib mlt Threads::Threads)
 find_package(SDL2 QUIET)
-if(TARGET SDL2::SDL2)
-    add_library(sdl2 ALIAS SDL2::SDL2)
+if(SDL2_FOUND)
+    add_library(sdl2 SHARED IMPORTED GLOBAL)
+    set_target_properties(sdl2 PROPERTIES
+        INTERFACE_INCLUDE_DIRECTORIES ${SDL2_INCLUDE_DIRS}
+        IMPORTED_LOCATION ${libdir}/libSDL2.so
+    )
 else()
     pkg_check_modules(sdl2 IMPORTED_TARGET GLOBAL sdl2)
     if(TARGET PkgConfig::sdl2)

=== src/melt/Makefile ===
include ../../config.mak

OBJS = melt.o \
	   io.o

CFLAGS += -I.. $(RDYNAMIC) -DVERSION=\"$(version)\"

LDFLAGS += -L../framework -lmlt -lpthread

SRCS := $(OBJS:.o=.c)

ifeq (, $(findstring MELT_NOSDL, $(CFLAGS)))
ifeq (yes, $(shell pkg-config --exists sdl2 && echo yes))
CFLAGS += -DHAVE_SDL2
CFLAGS  += $(shell pkg-config --cflags sdl2)
LDFLAGS += $(shell pkg-config --libs sdl2)
else ifeq (yes, $(shell pkg-config --exists sdl && echo yes))
CFLAGS  += $(shell pkg-config --cflags sdl)
LDFLAGS += $(shell pkg-config --libs sdl)
else
CFLAGS  += $(shell sdl-config --cflags)
LDFLAGS += $(shell sdl-config --libs)
endif
endif

ifeq ($(targetos), MinGW)
LDFLAGS += -mconsole
ifeq ($(windeploy), true)
bindir = $(prefix)
endif
endif

all: $(meltname)

$(meltname): $(OBJS)
		$(CC) -o $@ $(OBJS) $(LDFLAGS)

depend:	$(SRCS)
		$(CC) -MM $(CFLAGS) $^ 1>.depend

distclean:	clean
		rm -f .depend

clean:	
		rm -f $(OBJS) $(meltname)

install:	all
	install -d "$(DESTDIR)$(bindir)"
	install -c -m 755 $(meltname) "$(DESTDIR)$(bindir)"
ifeq ($(extra_versioning), true)
ifeq ($(melt_noversion), false)
	ln -s $(meltname) "$(DESTDIR)$(bindir)/melt"
endif
endif

uninstall:
	rm -f "$(DESTDIR)$(bindir)/$(meltname)"
ifeq ($(extra_versioning), true)
ifeq ($(melt_noversion), false)
	rm -f "$(DESTDIR)$(bindir)/melt"
endif
endif

ifneq ($(wildcard .depend),)
include .depend
endif

=== src/mlt++/CMakeLists.txt ===
file(GLOB mlt++_src *.cpp)
add_library(mlt++ SHARED ${mlt++_src})
set_target_properties(mlt++ PROPERTIES SOVERSION 3 VERSION 3 CXX_STANDARD 14)
if(WIN32)
    target_compile_definitions(mlt++ PUBLIC MLTPP_EXPORTS)
endif()
target_include_directories(mlt++ PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/../)
target_link_libraries(mlt++ mlt)
if(WIN32)
    install(TARGETS mlt++ DESTINATION ${CMAKE_INSTALL_BINDIR})
else()
    install(TARGETS mlt++ DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

file(GLOB mlt++_head *.h)
install(FILES ${mlt++_head} DESTINATION include/mlt++)

configure_file(mlt++.pc.in mlt++.pc @ONLY)
install (FILES
    ${CMAKE_CURRENT_BINARY_DIR}/mlt++.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
    COMPONENT Development)

=== src/mlt++/Makefile ===
include ../../config.mak
include config.mak
INSTALL = install

NAME = libmlt++$(LIBSUF)
ifeq ($(targetos), Darwin)
	TARGET = libmlt++.$(version)$(LIBSUF)
	SONAME = libmlt++.$(soversion)$(LIBSUF)
	LIBFLAGS += -install_name $(libdir)/$(SONAME) -current_version $(version) -compatibility_version $(soversion)
else ifeq ($(targetos), MinGW)
	TARGET = libmlt++-$(soversion)$(LIBSUF)
	CXXFLAGS += -DMLTPP_EXPORTS
	LIBFLAGS += -Wl,--output-def,libmlt++.def
else
	TARGET = $(NAME).$(version)
	SONAME = $(NAME).$(soversion)
	LIBFLAGS += -Wl,-soname,$(SONAME)
endif
ifneq (, $(shell $(CXX) --version | grep -is -e g++ -e clang))
	CXXFLAGS += -std=c++11
endif
CXXFLAGS += -I.. $(RDYNAMIC) -DVERSION=\"$(version)\" -fvisibility=hidden

LDFLAGS := -L../framework -lmlt $(LDFLAGS)
ifeq ($(targetos), Linux)
LDFLAGS += -Wl,--version-script=mlt++.vers
endif

OBJS = MltAnimation.o \
	   MltConsumer.o \
	   MltDeque.o \
	   MltEvent.o \
	   MltFactory.o \
	   MltField.o \
	   MltFilter.o \
	   MltFilteredConsumer.o \
	   MltFilteredProducer.o \
	   MltFrame.o \
	   MltGeometry.o \
	   MltMultitrack.o \
	   MltParser.o \
	   MltPlaylist.o \
	   MltProducer.o \
	   MltProfile.o \
	   MltProperties.o \
	   MltPushConsumer.o \
	   MltRepository.o \
	   MltService.o \
	   MltTokeniser.o \
	   MltTractor.o \
	   MltTransition.o

SRCS = $(OBJS:.o=.cpp)
HEADERS = MltConfig.h Mlt.h $(OBJS:.o=.h)

all:		$(TARGET)

$(TARGET):	$(OBJS)
	$(CXX) $(LIBFLAGS) -o $@ $(OBJS) $(LDFLAGS)
	ln -sf $(TARGET) $(NAME)
	if [ "$(targetos)" != "MinGW" ]; then \
		ln -sf $(TARGET) $(SONAME) ; \
	fi

depend:	$(SRCS)
	$(CXX) -MM $(CXXFLAGS) $^ 1>.depend

clean:
	$(RM) $(OBJS) $(TARGET) $(NAME) $(SONAME) libmlt++.def

distclean:	clean

install:
	$(INSTALL) -d "$(DESTDIR)$(libdir)"
	if [ "$(targetos)" = "MinGW" ]; then \
		if [ "$(windeploy)" = true ]; then \
			$(INSTALL) -m 755 $(TARGET) "$(DESTDIR)$(prefix)" ; \
			$(INSTALL) -m 755 $(TARGET) "$(DESTDIR)$(libdir)/libmlt++.dll" ; \
		else \
			$(INSTALL) -m 755 $(TARGET) "$(DESTDIR)$(bindir)" ; \
			$(INSTALL) -m 755 $(TARGET) "$(DESTDIR)$(bindir)/libmlt++.dll" ; \
		fi; \
		$(INSTALL) -m 644 libmlt++.def "$(DESTDIR)$(libdir)" ; \
	else \
		$(INSTALL) -m 755 $(TARGET) $(DESTDIR)$(libdir) ; \
		ln -sf $(TARGET) $(DESTDIR)$(libdir)/$(SONAME) ; \
		ln -sf $(TARGET) $(DESTDIR)$(libdir)/$(NAME) ; \
	fi
	$(INSTALL) -d "$(DESTDIR)$(prefix)/include/mlt++"
	$(INSTALL) -m 644 $(HEADERS) "$(DESTDIR)$(prefix)/include/mlt++"

uninstall:
	rm -f "$(DESTDIR)$(libdir)/$(TARGET)"
	if [ "$(targetos)" != "MinGW" ]; then \
		rm -f "$(DESTDIR)$(libdir)/$(NAME)" ; \
		rm -f "$(DESTDIR)$(libdir)/$(SONAME)" ; \
	else \
		if [ "$(windeploy)" = true ]; then \
			rm -f "$(DESTDIR)$(prefix)/$(TARGET)" ; \
			rm -f "$(DESTDIR)$(libdir)/libmlt++.dll" ; \
		else \
			rm -f "$(DESTDIR)$(bindir)/$(TARGET)" ; \
			rm -f "$(DESTDIR)$(bindir)/libmlt++.dll" ; \
		fi ; \
		rm -f "$(DESTDIR)$(libdir)/libmlt++.def" ; \
	fi
	rm -rf "$(DESTDIR)$(prefix)/include/mlt++"

ifneq ($(wildcard .depend),)
include .depend
endif

=== src/modules/Makefile ===
include ../../config.mak
include make.inc

all clean depend:
	list='$(SUBDIRS)'; \
	for subdir in $$list; do \
		if [ -f $$subdir/Makefile -a ! -f disable-$$subdir -a ! -f $$subdir/deprecated ] ; \
		then $(MAKE) -C $$subdir $@ || exit 1; \
		fi \
	done

distclean:
	rm -f consumers.dat filters.dat producers.dat transitions.dat
	echo > make.inc
	list='$(SUBDIRS)'; \
	for subdir in $$list; do \
		if [ -f $$subdir/Makefile -a ! -f disable-$$subdir -a ! -f $$subdir/deprecated ] ; \
		then $(MAKE) -C $$subdir $@ || exit 1; \
		fi \
	done

install:
	list='$(SUBDIRS)'; \
	for subdir in $$list; do \
		if [ -f $$subdir/Makefile -a ! -f disable-$$subdir -a ! -f $$subdir/deprecated ] ; \
		then $(MAKE) DESTDIR=$(DESTDIR) -C $$subdir $@ || exit 1; \
		fi \
	done

uninstall:
	rm -rf "$(DESTDIR)$(moduledir)"

=== src/swig/Makefile ===
include ../../config.mak
include config.mak

all clean:
	list='$(SUBDIRS)'; \
	for subdir in $$list; do \
		if [ -x $$subdir/build -a ! -f .$$subdir -o $@ = clean ] ; \
		then echo -n Building $$subdir... ; \
			cd $$subdir && CXXFLAGS="$(CXXFLAGS)" ./build $@ 2>&1; \
			if [ $$? -eq 0 ] ; \
			then echo OK && touch ../.$$subdir ; \
			else exit 1 ; \
			fi ; \
			cd .. ; \
			if [ -f $$subdir/Makefile -a -f .$$subdir ] ; \
			then $(MAKE) -C $$subdir $@ || exit 1 ; \
			fi ; \
			if [ $@ = clean ] ; \
			then rm -f .$$subdir ; \
			fi ; \
		fi \
	done

distclean: clean

depend:

install:

uninstall:

=== src/modules/avformat/CMakeLists.txt ===
#list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
#find_package(FFmpeg)
pkg_check_modules(libavformat IMPORTED_TARGET libavformat)
pkg_check_modules(libswscale IMPORTED_TARGET libswscale)
pkg_check_modules(libavutil IMPORTED_TARGET libavutil)
if(     TARGET PkgConfig::libavformat
    AND TARGET PkgConfig::libswscale
    AND TARGET PkgConfig::libavutil)
    set(mltavformat_libs
        mlt m Threads::Threads
        PkgConfig::libavformat
        PkgConfig::libswscale
        PkgConfig::libavutil)
    set(mltavformat_defs FILTERS)
    if(WIN32)
        list(APPEND mltavformat_defs AVDATADIR="share/ffmpeg/")
    endif()
    set(mltavformat_srcs
        common.c
        factory.c
        filter_avcolour_space.c
        filter_avdeinterlace.c
        filter_swscale.c)
    pkg_check_modules(libavcodec IMPORTED_TARGET libavcodec)
    if(TARGET PkgConfig::libavcodec)
        list(APPEND mltavformat_libs PkgConfig::libavcodec)
        list(APPEND mltavformat_defs CODECS)
        list(APPEND mltavformat_srcs
            producer_avformat.c
            consumer_avformat.c)
    endif()
    pkg_check_modules(libavfilter IMPORTED_TARGET libavfilter)
    if(TARGET PkgConfig::libavfilter)
        list(APPEND mltavformat_libs PkgConfig::libavfilter)
        list(APPEND mltavformat_defs FILTERS AVFILTER )
        list(APPEND mltavformat_srcs
            filter_avfilter.c)
    endif()
    pkg_check_modules(libavdevice IMPORTED_TARGET libavdevice)
    if(TARGET PkgConfig::libavdevice)
        list(APPEND mltavformat_libs PkgConfig::libavdevice)
        list(APPEND mltavformat_defs AVDEVICE)
    endif()
    pkg_check_modules(libswresample IMPORTED_TARGET libswresample)
    if(TARGET PkgConfig::libswresample)
        list(APPEND mltavformat_libs PkgConfig::libswresample)
        list(APPEND mltavformat_defs SWRESAMPLE)
        list(APPEND mltavformat_srcs
            filter_swresample.c)
    endif()
    add_library(mltavformat MODULE ${mltavformat_srcs})
    target_link_libraries(mltavformat ${mltavformat_libs})
    target_compile_definitions(mltavformat PRIVATE ${mltavformat_defs})
    install(TARGETS mltavformat LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/mlt)
    install(FILES blacklist.txt producer_avformat.yml consumer_avformat.yml
        DESTINATION ${CMAKE_INSTALL_DATADIR}/mlt/avformat)
endif()

=== src/modules/avformat/Makefile ===
CFLAGS += -I../..
LDFLAGS += -L../../framework -lmlt -lpthread -lm

ifneq (, $(shell $(CC) --version | grep -is -e 'Free Software Foundation'))
	LDFLAGS += -latomic
endif

include ../../../config.mak
include config.mak

LDFLAGS += $(EXTRA_LIBS)

ifndef CODECS
TARGET = ../libmltffmpeg$(LIBSUF)
else
TARGET = ../libmltavformat$(LIBSUF)
endif

OBJS = common.o \
       factory.o

ifdef FILTERS
OBJS += filter_avcolour_space.o \
	    filter_avdeinterlace.o \
	    filter_swscale.o
CFLAGS += -DFILTERS
endif

ifdef VDPAU
CFLAGS += -DVDPAU $(shell pkg-config pkg-config --cflags x11)
LDFLAGS += $(LIBDL) $(shell pkg-config pkg-config --libs x11)
endif

ifdef CODECS
OBJS += producer_avformat.o \
	    consumer_avformat.o
CFLAGS += -DCODECS
endif

ifdef DEVICES
CFLAGS += -DAVDEVICE
endif

ifdef AVFILTER
CFLAGS += -DAVFILTER
OBJS += filter_avfilter.o
endif

ifdef SWRESAMPLE
OBJS += filter_swresample.o
CFLAGS += -DSWRESAMPLE
endif

SRCS := $(OBJS:.o=.c)

all: 	$(TARGET)

$(TARGET): $(OBJS)
	$(CC) $(SHFLAGS) -o $@ $(OBJS) $(LDFLAGS)

depend:	$(SRCS)
	$(CC) -MM $(CFLAGS) $^ 1>.depend

distclean:	clean
	rm -f .depend

clean:	
	rm -f $(OBJS) ../libmltffmpeg$(LIBSUF) ../libmltavformat$(LIBSUF)

install: all
	install -m 755 $(TARGET) "$(DESTDIR)$(moduledir)"
	install -d "$(DESTDIR)$(mltdatadir)/avformat"
	install -m 644 blacklist.txt "$(DESTDIR)$(mltdatadir)/avformat"
	install -m 644 producer_avformat.yml "$(DESTDIR)$(mltdatadir)/avformat"
	install -m 644 consumer_avformat.yml "$(DESTDIR)$(mltdatadir)/avformat"

uninstall:
	rm -f "$(DESTDIR)$(moduledir)/libmltavformat$(LIBSUF)"
	rm -f "$(DESTDIR)$(moduledir)/libmltffmpeg$(LIBSUF)"
	rm -rf "$(DESTDIR)$(mltdatadir)/avformat"

ifneq ($(wildcard .depend),)
include .depend
endif

=== debian/changelog ===
mlt (6.20.0-2) unstable; urgency=medium

  * Drop patch 01-fix-link-atomic64.

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 02 Mar 2020 11:33:00 +0100

mlt (6.20.0-1) unstable; urgency=medium

  * New upstream release.
    - Refresh patch 01-fix-link-atomic64.

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 17 Feb 2020 15:10:08 +0100

=== debian/control ===
Source: mlt
Priority: optional
Maintainer: Patrick Matthäi <pmatthaei@debian.org>
Build-Depends: debhelper-compat (= 12),
 ffmpeg,
 libqt5opengl5-dev,
 libqt5svg5-dev,
 ladspa-sdk,
 libavdevice-dev,
 libavformat-dev,
 libdv4-dev,
 libgtk2.0-dev,
 libexif-dev,
 libexif-gtk-dev,
 libmovit-dev,
 libfftw3-dev,
 libjack-dev,
 libsamplerate-dev,
 libsdl1.2-dev,
 libsdl2-dev,
 libsox-dev (>= 14.3.0),
 libswscale-dev,
 libvorbis-dev,
 libvidstab-dev,
 libxine2-dev,
 libxml2-dev,
 librtaudio-dev [linux-any],
 imagemagick,
 frei0r-plugins-dev,
 swig,
 libebur128-dev (>= 1.2.0-2),
 python3-dev,
 dh-python
Standards-Version: 4.5.0
Section: libs
Rules-Requires-Root: no
Homepage: https://www.mltframework.org

Package: libmlt-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
 libmlt6 (= ${binary:Version})
Description: multimedia framework (development)
 MLT is an open source multimedia framework, designed and developed for
 television broadcasting. It provides a toolkit for broadcasters, video
 editors, media players, transcoders, web streamers and many more types of
 applications. The functionality of the system is provided via an assortment
 of ready to use tools, xml authoring components, and an extendible plug-in
 based API.
 .
 This package contains the static libraries and headers for developing
 applications that use the MLT multimedia framework.

Package: libmlt6
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Recommends: libmlt-data (>= ${source:Version})
Description: multimedia framework (runtime)
 MLT is an open source multimedia framework, designed and developed for
 television broadcasting. It provides a toolkit for broadcasters, video
 editors, media players, transcoders, web streamers and many more types of
 applications. The functionality of the system is provided via an assortment
 of ready to use tools, xml authoring components, and an extendible plug-in
 based API.
 .
 This package contains the files necessary for running applications that
 use the MLT multimedia framework.

Package: libmlt-data
Architecture: all
Depends: ${misc:Depends}
Enhances: libmlt6
Description: multimedia framework (data)
 MLT is an open source multimedia framework, designed and developed for
 television broadcasting. It provides a toolkit for broadcasters, video
 editors, media players, transcoders, web streamers and many more types of
 applications. The functionality of the system is provided via an assortment
 of ready to use tools, xml authoring components, and an extendible plug-in
 based API.
 .
 This package contains the data files for the MLT multimedia framework.

Package: libmlt++-dev
Section: libdevel
Architecture: any
Depends: libmlt++3 (= ${binary:Version}),
 ${misc:Depends}
Description: MLT multimedia framework C++ wrapper (development)
 MLT is an open source multimedia framework, designed and developed for
 television broadcasting. It provides a toolkit for broadcasters, video
 editors, media players, transcoders, web streamers and many more types of
 applications. The functionality of the system is provided via an assortment
 of ready to use tools, xml authoring components, and an extendible plug-in
 based API.
 .
 This package contains the static libraries and headers for developing
 applications that use the MLT multimedia framework C++ wrapper.

Package: libmlt++3
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: MLT multimedia framework C++ wrapper (runtime)
 MLT is an open source multimedia framework, designed and developed for
 television broadcasting. It provides a toolkit for broadcasters, video
 editors, media players, transcoders, web streamers and many more types of
 applications. The functionality of the system is provided via an assortment
 of ready to use tools, xml authoring components, and an extendible plug-in
 based API.
 .
 This package contains the files necessary for running applications that
 use the MLT multimedia framework C++ wrapper.

Package: melt
Section: utils
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 libmlt-data (>= ${source:Version})
Description: command line media player and video editor
 melt was meant as a test tool for the MLT framework, but it is also a powerful
 multitrack command line oriented video editor. It could also used as an
 minimalistic media player for audio and video files.

Package: python3-mlt
Architecture: any
Section: python
Depends: ${shlibs:Depends},
 ${misc:Depends},
 ${python3:Depends}
Provides: ${python3:Provides}
Conflicts: python-mlt
Replaces: python-mlt
Description: multimedia framework (Python bindings)
 MLT is an open source multimedia framework, designed and developed for
 television broadcasting. It provides a toolkit for broadcasters, video
 editors, media players, transcoders, web streamers and many more types of
 applications. The functionality of the system is provided via an assortment
 of ready to use tools, xml authoring components, and an extendible plug-in
 based API.
 .
 This package contains the Python bindings for the mlt package.

=== debian/rules ===
--- 
+++ 
@@ -38,6 +38,3 @@
 
 override_dh_makeshlibs:
 	dh_makeshlibs -V
-
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym

## mlt 6.22.0

=== CMakeLists.txt ===
project(MLT)
set(MLT_VERSION 6.21.0)
cmake_minimum_required(VERSION 3.10)
find_package(PkgConfig REQUIRED)
include(GNUInstallDirs)
option(GPL "Enable GPLv2 modules" ON)
option(GPL3 "Enable GPLv3 modules" ON)
if(WIN32)
  option(NODEPLOY "Keep bin/ lib/ layout on Windows" ON)
endif()
if(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86_64)|(AMD64)")
    set(X86_64 ON)
    if(NOT MSVC)
        add_definitions(-DUSE_MMX -DUSE_SSE -DUSE_SSE2 -DARCH_X86_64)
    endif()
endif()
if(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang")
    add_compile_options(-ffast-math)
elseif(MSVC)
    add_compile_options(/fp:fast)
endif()
find_package(Threads REQUIRED)
find_package(FFTW QUIET)
if(NOT FFTW_FOUND)
    pkg_check_modules(FFTW fftw3)
endif()
if(NOT FFTW_FOUND)
    pkg_check_modules(FFTW fftw)
endif()
pkg_check_modules(xml IMPORTED_TARGET libxml-2.0)
add_subdirectory(src/framework)
add_subdirectory(src/melt)
add_subdirectory(src/mlt++)
#add_subdirectory(src/swig)
#file(GLOB modules src/modules/*/)
set(modules
    src/modules/avformat
    src/modules/core
    src/modules/decklink
    src/modules/frei0r
    src/modules/feeds
    src/modules/gdk
    src/modules/jackrack
    src/modules/kdenlive
    src/modules/motion_est
    src/modules/normalize
    src/modules/oldfilm
    src/modules/opencv
    src/modules/opengl
    src/modules/plus
    src/modules/plusgpl
    src/modules/qt
    src/modules/resample
    src/modules/rubberband
    src/modules/rtaudio
    src/modules/sdl2
    src/modules/sox
    src/modules/vid.stab
    src/modules/vmfx
    src/modules/vorbis
    src/modules/xine
    src/modules/xml
    src/modules/lumas
)
foreach(module ${modules})
    add_subdirectory(${module})
endforeach()
install(DIRECTORY profiles DESTINATION ${CMAKE_INSTALL_DATADIR}/mlt)
install(DIRECTORY presets DESTINATION ${CMAKE_INSTALL_DATADIR}/mlt)

=== debian/changelog ===
mlt (6.22.0-1) unstable; urgency=medium

  * New upstream release.
  * Adjust debian/copyright.

 -- Patrick Matthäi <pmatthaei@debian.org>  Fri, 31 Jul 2020 11:20:48 +0200

mlt (6.20.0-3) unstable; urgency=high

  * Upgrade debhelper-compat to level 13.
  * Rebuild against newer ffmpeg.
    Closes: #963706

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 14 Jul 2020 09:17:46 +0200
